#ifndef __GENERATE_UTILS_H__
#define __GENERATE_UTILS_H__

/* Terrain generation utility functions. */

#include "heightmap.h"

// Seed rand() and GU_noise()
void GU_seed(const unsigned int seed);
// Generate random numer with gaussian distribution
float GU_noise();

// Add a sphere at x, y, z
// NOTE: Only overwrites air
void GU_sphere(const float x, const float y, const float z, const float radius, const unsigned short type);
// Try and add a tree on the heightest grass surface at vx, vz
void GU_tree(const int vx, const int vz);
// Try and add a giant mushroom on the lowest stone surface at vx, vz
void GU_mushroom(const int vx, const int vz);
// Try and a cactus on the heighest sand surface vx, vz
void GU_cactus(const int vx, const int vz);
// Add stalactites to the bottom of any voxels of the specified type
void GU_stalactites(const int length, const unsigned short type);
// Add plants, sunEnabled should be true if the world is exposed to the sun
void GU_undergrowth(const char sunEnabled);
// Add ore and empty spaces in veins to stone
void GU_ore(const int seamLength);
// Add a layer of clouds at height y
// NOTE: Only overwrites air
void GU_cloud(const Heightmap *data, const int y);
// Apply gravity to specified type
void GU_collapse(const unsigned short type);

#endif

