/* Logging/debugging tools. */

#include <string.h>
#include <errno.h>
#include <SDL2/SDL.h>

// Crash with an error
void log_crash(const char *message);

// Print information
#define LOG_INFO(message) SDL_LogInfo(SDL_LOG_CATEGORY_APPLICATION, "%s", message);

// Print warning
#define LOG_WARN(message) SDL_LogWarn(SDL_LOG_CATEGORY_APPLICATION, "%s", message);

// Wrapper for SDL_LogError that behaves like perror()
#define LOG_PERROR(message) SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "%s: %s", message, strerror(errno))

// Print error
#define LOG_ERROR(message) SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "%s", message);

