#ifndef __PERSPECTIVEGL_H__
#define __PERSPECTIVEGL_H__

//#include <GL/gl.h>
#include <math.h>
#include "gl_load.h"

/* From http://nehe.gamedev.net/article/replacement_for_gluperspective/21002/
Replaces gluPerspective. Sets the frustum to perspective mode.
fovY     - Field of vision in degrees in the y direction
aspect   - Aspect ratio of the viewport
zNear    - The near clipping distance
zFar     - The far clipping distance */
void perspectiveGL(GLdouble fovY, GLdouble aspect, GLdouble zNear, GLdouble zFar) {
	const GLdouble pi = 3.1415926535897932384626433832795;
	GLdouble fW, fH;
	fH = tan(fovY / 360 * pi) * zNear;
	fW = fH * aspect;
	glFrustum(-fW, fW, -fH, fH, zNear, zFar);
}

#endif